# Class ExecutorReactor

java.lang.Object
org.simpleframework.transport.reactor.ExecutorReactor

All Implemented Interfaces:
  `Reactor`

public class ExecutorReactor extends Object implements Reactor
The `ExecutorReactor` is used to schedule operation for execution using an `Executor` implementation. This can be useful when the operations performed are time intensive. For example if the operations performed a read of the underlying channel and then had to parse the contents of the payload. Such operations would reduce the performance of the reactor if it could not delegate to some other form of executor, as it would delay their execution.

Author:
  Niall Gallagher

## Constructor Summary

Constructors
Constructor
Description
`ExecutorReactor(Executor executor)`
Constructor for the `ExecutorReactor` object.
`ExecutorReactor(Executor executor, int count)`
Constructor for the `ExecutorReactor` object.
`ExecutorReactor(Executor executor, int count, long expiry)`
Constructor for the `ExecutorReactor` object.

## Method Summary

Modifier and Type
Method
Description
`void`
`process(Operation task)`
This method is used to execute the provided operation without the need to specifically check for I/O events.
`void`
`process(Operation task, int require)`
This method is used to execute the provided operation when there is an I/O event that task is interested in.
`void`
`stop()`
This is used to stop the reactor so that further requests to execute operations does nothing.

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### ExecutorReactor

public ExecutorReactor(Executor executor) throws IOException
Constructor for the `ExecutorReactor` object. This is used to create a reactor that can delegate to the executor. This also accepts the operations it is interested in, the value is taken from the `SelectionKey` object. A bit mask can be used to show interest in several operations at once.

Parameters:
  `executor` - this is the executor used to run the operations
Throws:
  `IOException`

### ExecutorReactor

public ExecutorReactor(Executor executor, int count) throws IOException
Constructor for the `ExecutorReactor` object. This is used to create a reactor that can delegate to the executor. This also accepts the operations it is interested in, the value is taken from the `SelectionKey` object. A bit mask can be used to show interest in several operations at once.

Parameters:
  `executor` - this is the executor used to run the operations
  `count` - this is the number of distributors to be used
Throws:
  `IOException`

### ExecutorReactor

public ExecutorReactor(Executor executor, int count, long expiry) throws IOException
Constructor for the `ExecutorReactor` object. This is used to create a reactor that can delegate to the executor. This also accepts the operations it is interested in, the value is taken from the `SelectionKey` object. A bit mask can be used to show interest in several operations at once.

Parameters:
  `executor` - this is the executor used to run the operations
  `count` - this is the number of distributors to be used
  `expiry` - the length of time to maintain and idle operation
Throws:
  `IOException`

## Method Details

### process

public void process(Operation task) throws IOException
This method is used to execute the provided operation without the need to specifically check for I/O events. This is used if the operation knows that the `SelectableChannel` is ready, or if the I/O operation can be performed without knowing if the channel is ready. Typically this is an efficient means to perform a poll rather than a select on the channel.

Specified by:
  `process` in interface `Reactor`
Parameters:
  `task` - this is the task to execute immediately
Throws:
  `IOException`

### process

public void process(Operation task, int require) throws IOException
This method is used to execute the provided operation when there is an I/O event that task is interested in. This will used the operations `SelectableChannel` object to determine the events that are ready on the channel. If this reactor is interested in any of the ready events then the task is executed.

Specified by:
  `process` in interface `Reactor`
Parameters:
  `task` - this is the task to execute on interested events
  `require` - this is the bit-mask value for interested events
Throws:
  `IOException`

### stop

public void stop() throws IOException
This is used to stop the reactor so that further requests to execute operations does nothing. This will clean up all of the reactors resources and unregister any operations that are currently awaiting execution. This should be used to ensure any threads used by the reactor gracefully stop.

Specified by:
  `stop` in interface `Reactor`
Throws:
  `IOException`